function ClassIcons_OnLoad()

	SlashCmdList["CLASSICONS"] = ClassIcons_CmdHandler;
	SLASH_CLASSICONS1 = "/classicons";
	SLASH_CLASSICONS2 = "/ci";

	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");

end

function ClassIcons_CmdHandler(msg)

	if ( msg == "on" ) then
		CLASSICONS_CONFIG.Active = true;

		ClassIcons_OnEvent["PLAYER_TARGET_CHANGED"]();
		ClassIcons_OnEvent["PARTY_MEMBERS_CHANGED"]();

		return;
	end

	if ( msg == "off" ) then
		CLASSICONS_CONFIG.Active = false;

		ClassIcons_OnEvent["PLAYER_TARGET_CHANGED"]();
		ClassIcons_OnEvent["PARTY_MEMBERS_CHANGED"]();

		return;
	end

end

function ClassIcons_UpdateIcon(frame, unit)

	if ( not frame ) or ( not unit ) then
		return;
	end

	local icon = getglobal(frame.."ClassIcon");
	local texture = getglobal(frame.."ClassIconTexture");

	if ( not icon ) or ( not texture ) then
		return;
	end

	local UnitIsMob = not UnitIsPlayer(unit);
	local localizedClass, englishClass = UnitClass(unit);

	if ( CLASSICONS_CONFIG.Active == false ) or ( UnitIsMob )then
		if ( icon:IsVisible() ) then icon:Hide(); end
		return;
	end

	if ( not englishClass ) then
		return;
	end

	if ( not icon:IsVisible() ) then
		icon:Show();
	end

	texture:SetTexture("Interface\\AddOns\\ClassIcons\\Icons\\"..englishClass);

end

function ClassIcons_OnEvent(event)

	if ( event == "VARIABLES_LOADED" ) or ( event == "PLAYER_ENTERING_WORLD" ) then

		if ( CLASSICONS_CONFIG == nil ) then
			CLASSICONS_CONFIG = { };
		end
		if ( CLASSICONS_CONFIG.Active == nil ) then
			CLASSICONS_CONFIG.Active = true;
		end
--		ClassIcons_UpdateIcon("PlayerFrame", "Player");
		for i = 1, 4 do
				ClassIcons_UpdateIcon("PartyMemberFrame"..i, "party"..i);
		end

	elseif ( event == "PLAYER_TARGET_CHANGED" ) or ( event == "TARGET_TARGET_CHANGED" ) then

		ClassIcons_UpdateIcon("TargetFrame", "target");

	elseif ( event == "PARTY_MEMBERS_CHANGED" ) or ( event == "PARTY_MEMBER_ENABLE" ) then

		for i = 1, 4 do
				ClassIcons_UpdateIcon("PartyMemberFrame"..i, "party"..i);
		end
		
	end

end

function ClassIcons_Icon_OnLoad()
	this:SetFrameLevel(this:GetFrameLevel()+2);
end
