HOTKEY_TEXT_COLOR = HOTKEY_TEXT_COLOR or {1, 1, 1}

-- 특성버튼 위치 변경 고정 삭제
TalentMicroButton:SetScript("OnUpdate", function()
	if ( UnitLevel("player") < 10 ) then
		this:Disable()
	else
		this:Enable()
		this:SetScript("OnUpdate", nil)
	end
end)

function UpdateTalentButton()
--[[ 전부 삭제 ]]
end

-- 거리에 따른 아이콘 색상 변경에 따른 기능 추가
function ActionButton_OnUpdate(elapsed)
	local hotkey = getglobal(this:GetName().."HotKey")
	local button = ActionButton_GetPagedID(this)

	if ( hotkey:GetText() == RANGE_INDICATOR ) then
		if ( ToolsBarDB ) then
			if (ToolsBarDB.RangeColor) then
				hotkey:Hide()
			else
				if ( IsActionInRange(button) == 1 ) then
					hotkey:Hide();
				else
					hotkey:Show();
				end
			end
		else
			if ( IsActionInRange(button) == 1 ) then
				hotkey:Hide();
			else
				hotkey:Show();
			end
		end
	end

	if ( ActionButton_IsFlashing() ) then
		this.flashtime = this.flashtime - elapsed;
		if ( this.flashtime <= 0 ) then
			local overtime = -this.flashtime;
			if ( overtime >= ATTACK_BUTTON_FLASH_TIME ) then
				overtime = 0;
			end
			this.flashtime = ATTACK_BUTTON_FLASH_TIME - overtime;

			local flashTexture = getglobal(this:GetName().."Flash");
			if ( flashTexture:IsVisible() ) then
				flashTexture:Hide();
			else
				flashTexture:Show();
			end
		end
	end
	
	-- 기존 버튼 배경 삭제 추가
	if this.showgrid == 0 then
		this:SetNormalTexture("")
	end

	-- Handle range indicator
	if ( this.rangeTimer ) then
		this.rangeTimer = this.rangeTimer - elapsed;

		if ( this.rangeTimer <= 0 ) then
			if ( IsActionInRange(button) == 0 ) then
				hotkey:SetVertexColor(1, .1, .1)
			else
				-- 기본 색상값 회색에서 사용자정의로 변경
				hotkey:SetVertexColor(unpack(HOTKEY_TEXT_COLOR))
			end
			this.rangeTimer = TOOLTIP_UPDATE_TIME;
		end
	end

	ActionButton_UpdateUsable()

	if ( not this.updateTooltip ) then
		return;
	end

	this.updateTooltip = this.updateTooltip - elapsed;
	if ( this.updateTooltip > 0 ) then
		return;
	end

	if ( GameTooltip:IsOwned(this) ) then
		ActionButton_SetTooltip();
	else
		this.updateTooltip = nil;
	end
end

function ActionButton_UpdateUsable()
	local icon = getglobal(this:GetName().."Icon")
	local normalTexture = getglobal(this:GetName().."NormalTexture")
	local isUsable, notEnoughMana = IsUsableAction(ActionButton_GetPagedID(this))

-- 거리에 따른 색상 추가
	if (ToolsBarDB) then
		if (ToolsBarDB.RangeColor) and (IsActionInRange(ActionButton_GetPagedID(this)) == 0) then
			icon:SetVertexColor(1, .1, .1)
			return
		end
	end
	if ( isUsable ) then
		icon:SetVertexColor(1.0, 1.0, 1.0)
		normalTexture:SetVertexColor(1.0, 1.0, 1.0)
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.5, 0.5, 1.0)
		normalTexture:SetVertexColor(0.5, 0.5, 1.0)
	else
		icon:SetVertexColor(0.4, 0.4, 0.4)
		normalTexture:SetVertexColor(1.0, 1.0, 1.0)
	end
end

-- 거리 판별 단축키 위치 고정 제거
function ActionButton_UpdateHotkeys(actionButtonType)
     if ( not actionButtonType ) then
        actionButtonType = "ACTIONBUTTON";
    end
    local hotkey = getglobal(this:GetName().."HotKey");
    local button = ActionButton_GetPagedID(this);
    local key = GetBindingKey(actionButtonType..this:GetID()) or
                GetBindingKey("CLICK "..this:GetName()..":LeftButton");

    if ( GetBindingText(key, "KEY_", 1) == "" ) then
        if ( not HasAction(button) ) then
            hotkey:SetText("");
        elseif ( ActionHasRange(button) ) then
            if ( IsActionInRange(button) ) then
                hotkey:SetText(RANGE_INDICATOR);
                --hotkey:SetTextHeight(8);
                --hotkey:SetPoint("TOPRIGHT", this:GetName(), "TOPRIGHT", -3, 5);
            else
                hotkey:SetText("");
            end
        end
    else
       -- hotkey:SetText(GetBindingText(key, "KEY_", 1))
        local text = GetBindingText(key, "KEY_", 1)
        text = string.gsub(text, "마우스 가운데 버튼", "휠")
        text = string.gsub(text, "마우스 휠 아래로", "▼")
	text = string.gsub(text, "마우스 휠 위로", "▲")
        text = string.gsub(text, "숫자패드% ", "n-")
        text = string.gsub(text, "스페이스 바", "Sp")
        text = string.gsub(text, "Backspace", "Bs")
        text = string.gsub(text, "Page Up", "pU")
        text = string.gsub(text, "Page Down", "pD")
        text = string.gsub(text, "Home", "Hm")
        text = string.gsub(text, "Insert", "In")
        text = string.gsub(text, "Delete", "Dl")
        text = string.gsub(text, "End", "Ed")
        hotkey:SetText(text)
    end
end