--[  메뉴선택실행  ]
local function SortDropdownSelect(v)
	ToolsBarDB.Sort[v] = this:GetID()
	if v == "Bag" then
		ToolsBar:SetBagButton()
	else 
		ToolsBar:SetMicroButton()
	end
end
--[  메뉴체크확인  ]
local function SortDropdownCheck(v)
	if (ToolsBarDB.Sort[v[2]] == v[1]) then
		return 1
	end
	return nil
end
--[  옵션 애드온 확인  ]
local function OptionDropdownSelect()
	LoadAddOn("ToolsBar_Option")
	if (ToolsBar_OptionFrame) then
		ToolsBar_OptionFrame:Show()
	else
		tremove(ToolsDropdown.ToolsBarMinimap[1], this:GetID())
		UIErrorsFrame:AddMessage("Tool's Bar Option이 설치되어 있지 않아\n옵션 메뉴를 삭제 합니다", 1,0,0,1)
	end
end
--[ 툴팁설정선택 ]
local function TooltipDropdownSelect(v)
	if (ToolsBarDB.Tooltip[v]) then 
		ToolsBarDB.Tooltip[v] = nil
	else
		ToolsBarDB.Tooltip[v] = true
	end
end
-- [ 툴팁체크확인 ]
local function TooltipDropdownCheck(v)
	if (ToolsBarDB.Tooltip[v]) then
		return 1
	end
	return nil
end

--------------------------------------------------------------------------------[ 메뉴추가 ]
ToolsDropdown.ToolsBarMinimap = {
	 [1] = {{ text = "가방/메뉴 설정", isTitle = 1},
		{ value = "bagButton", text = "가방 확장 뱡향", notCheckable = 1, hasArrow = 1},
		{ value = "microButton", text = "메뉴 확장 방향", notCheckable = 1, hasArrow = 1},
		{ text = "", isTitle = 1},
		{ text = "툴팁 보이기 설정", isTitle = 1},
		{ value = "HELP", keepShownOnClick = 1, text = "도움말",
		   Check = "HELP", checkedfunc = TooltipDropdownCheck,
		   arg1 = "HELP", func = TooltipDropdownSelect},
		{ value = "EXP", keepShownOnClick = 1, text = "경험치",
		   Check = "EXP", checkedfunc = TooltipDropdownCheck,
		   arg1 = "EXP", func = TooltipDropdownSelect},
		{ value = "REP", keepShownOnClick = 1, text = "평판",
		   Check = "REP", checkedfunc = TooltipDropdownCheck, 
		   arg1 = "REP", func = TooltipDropdownSelect},
		{ value = "SYS", keepShownOnClick = 1, text = "메모리/지연율",
		   Check = "SYS", checkedfunc = TooltipDropdownCheck, 
		   arg1 = "SYS", func = TooltipDropdownSelect},
		{ value = "DURA", keepShownOnClick = 1, text = "내구도",
		   Check = "DURA", checkedfunc = TooltipDropdownCheck, 
		   arg1 = "DURA", func = TooltipDropdownSelect},
		{ value = "BAG", keepShownOnClick = 1, text = "가방공간",
		   Check = "BAG", checkedfunc = TooltipDropdownCheck, 
		   arg1 = "BAG", func = TooltipDropdownSelect},
		{ text = "", isTitle = 1},
		{ text = "옵션", justifyH="LEFT", func = OptionDropdownSelect}},
	 [2] ={
		{ owner = "bagButton", text = "위로 확장", arg1 = "Bag", func = SortDropdownSelect,
		   Check = {1,"Bag"}, checkedfunc = SortDropdownCheck},
		{ owner = "bagButton", text = "아래로 확장", arg1 = "Bag", func = SortDropdownSelect,
		   Check = {2,"Bag"}, checkedfunc = SortDropdownCheck},
		{ owner = "bagButton", text = "좌로 확장", arg1 = "Bag", func = SortDropdownSelect,
		   Check = {3,"Bag"}, checkedfunc = SortDropdownCheck},
		{ owner = "bagButton", text = "우로 확장", arg1 = "Bag", func = SortDropdownSelect,
		   Check = {4,"Bag"}, checkedfunc = SortDropdownCheck},
		{ owner = "microButton", text = "위로 확장", arg1 = "Micro", func = SortDropdownSelect,
		   Check = {1,"Micro"}, checkedfunc = SortDropdownCheck},
		{ owner = "microButton", text = "아래로 확장", arg1 = "Micro", func = SortDropdownSelect,
		   Check = {2,"Micro"}, checkedfunc = SortDropdownCheck},
		{ owner = "microButton", text = "좌로 확장", arg1 = "Micro", func = SortDropdownSelect,
		   Check = {3,"Micro"}, checkedfunc = SortDropdownCheck},
		{ owner = "microButton", text = "우로 확장", arg1 = "Micro", func = SortDropdownSelect,
		   Check = {4,"Micro"}, checkedfunc = SortDropdownCheck}}
}