local InvItemID = {1,3,5,6,7,8,9,10,16,17,18}	-- 아이템 장비창 내구도 있는 아이템 소켓번호
local FACTION_COLORS = {				-- 평판 우호도 색상
	[1] = "|CFFCC0000", -- 매우 적대
	[2] = "|CFFCC0000", -- 적대
	[3] = "|CFFCC8500", -- 약간 적대
	[4] = "|CFFE5B200", -- 중립
	[5] = "|CFF00BF45", -- 약간 우호
	[6] = "|CFF00C120", -- 우호
	[7] = "|CFF00C120", -- 매우 우호
	[8] = "|CFF3CFF7B"  -- 확고
}

-- [ 지연율 ]
local function get_latency()
	local _, _, latency = GetNetStats()
	if (latency > PERFORMANCEBAR_MEDIUM_LATENCY) then
		return "|CFFFF0000"..floor(latency).."|r|CFFFFFFFFms|r"
	elseif (latency > PERFORMANCEBAR_LOW_LATENCY) then
		return "|CFFC7B700"..floor(latency).."|r|CFFFFFFFFms|r"
	end
	return floor(latency)
end
-- [ 돈 단위 자르기 ]
local function CostSplit(cost)
	local gold = floor(cost / (COPPER_PER_SILVER * SILVER_PER_GOLD))
	local silver = floor((cost - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER)
	local copper = mod(cost, COPPER_PER_SILVER)

	if (gold ~= 0) then
		return format("%s%.0f%s %s%.0f%s %s%.0f%s", "|CFFFFFFFF",gold,"|r|CFFFFF000g|r", "|CFFFFFFFF",silver,"|r|CFFD3D3D0s|r", "|CFFFFFFFF",copper,"|r|CFFCBBF00c|r")
	elseif (silver ~= 0) then
		return format("%s%.0f%s %s%.0f%s", "|CFFFFFFFF",silver,"|r|CFFD3D3D0s|r", "|CFFFFFFFF",copper,"|r|CFFCBBF00c|r")
	else
		return format("%s%.0f%s",	"|CFFFFFFFF",copper,"|r|CFFCBBF00c|r")
	end
end
-- [ 가방칸 확인 ]
local function FindEmptySlot()
	local Empty_Count = 0
	local Use_Count = 0
	for i=0, NUM_BAG_FRAMES do
		for j=1, GetContainerNumSlots(i) do
			if not (GetContainerItemLink(i, j)) then
				Empty_Count = Empty_Count + 1
			else
				Use_Count = Use_Count + 1
			end
    		end
  	end
	return Empty_Count, Use_Count
end
-- [ 내구도 검사 ] 가방 제거
local function CheckDura(loop, bag)
	if not (ToolsBarTooltip) then
		CreateFrame("GameTooltip", "ToolsBarTooltip", UIParent, "GameTooltipTemplate")
	end
	ToolsBarTooltip:SetOwner(WorldFrame, "ANCHOR_NONE")
	local dura_value, dura_total, dura_cost = 0, 0, 0
	for i = 1, loop do
		local ok, c
--		if (bag) then
--			ok = GetContainerItemLink(bag, i)
--			_, c = ToolsBarTooltip:SetBagItem(bag, i)
--		else
			ok, _, c = ToolsBarTooltip:SetInventoryItem("player", InvItemID[i])
--		end
		if (ok) then
			dura_cost = dura_cost + c
			for j = 1, 30 do
				if not (getglobal("ToolsBarTooltipTextLeft"..j)) then break end
				local text = getglobal("ToolsBarTooltipTextLeft"..j):GetText()
				if (text) then
					local _, _, value1, value2 = string.find(text, "^내구도 (%d+) / (%d+)$")
					if (value1) then
						dura_value = dura_value + value1
						dura_total = dura_total + value2
						break
					end
				end
			end
		end
	end
	ToolsBarTooltip:Hide()
	return dura_value, dura_total, dura_cost
end

local function SetTooltip()
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT")
	GameTooltip:AddLine("|CFF7FFF7FTool's Bar|r "..ToolsBar.Version)
	if (ToolsBarDB.Tooltip.HELP) then
		GameTooltip:AddLine("|CFFFFFFFF좌클릭 : |r가방보기")
		GameTooltip:AddLine("|CFFFFFFFF우클릭 : |r메뉴보기")
		GameTooltip:AddLine("|CFFFFFFFFAlt + 좌클릭 : |r설정메뉴")
	end
	if (UnitLevel("player") ~= MAX_PLAYER_LEVEL) and (ToolsBarDB.Tooltip.EXP) then
		GameTooltip:AddLine(" ")
		local Xp = UnitXP("player")
		local maxXp = UnitXPMax("player")
		local rest = GetXPExhaustion()
		GameTooltip:AddLine("|CFF00AAFF경험치|r")
		GameTooltip:AddDoubleLine("|CFFFFFFFF현재 경험치 :|r "..format("%.0f / %.0f", Xp, maxXp), "|CFFFFFFFF"..format("%.2f %s", Xp/maxXp*100,"|CFFFFD200%"))
		if (rest) then
			GameTooltip:AddDoubleLine("|CFFFFFFFF휴식 경험치 :|r "..format("%.0f", rest), "|CFFFFFFFF"..format("%.2f %s", rest/maxXp*100,"|CFFFFD200%"))
		end
		GameTooltip:AddDoubleLine("|CFFFFFFFF남은 경험치 :|r "..format("%.0f", maxXp-Xp), "|CFFFFFFFF"..format("%.2f %s", (maxXp-Xp)/maxXp*100,"|CFFFFD200%"))
	end
	if (GetWatchedFactionInfo()) and (ToolsBarDB.Tooltip.REP) then
		GameTooltip:AddLine(" ")
		local rep = {GetWatchedFactionInfo()}
		local color = FACTION_COLORS[rep[2]]
		GameTooltip:AddLine("|CFF00AAFF평  판|r")
		GameTooltip:AddLine("|CFFFFFFFF세력명 :|r "..color..rep[1])
		GameTooltip:AddDoubleLine(color..getglobal("FACTION_STANDING_LABEL"..rep[2]).." :|r "..format("%.0f / %.0f", rep[5]-rep[3], rep[4]-rep[3]),"|CFFFFFFFF"..format("%.0f %s",(rep[5]-rep[3])/(rep[4]-rep[3])*100,"|CFFFFD200%"))
		GameTooltip:AddDoubleLine("|CFFFFFFFF남은 평판치 :|r "..format("%.0f",rep[4]-rep[3])-(rep[5]-rep[3]), "|CFFFFFFFF"..format("%.0f %s",((rep[4]-rep[3])-(rep[5]-rep[3]))/(rep[4]-rep[3])*100,"|CFFFFD200%"))
	end
	if (ToolsBarDB.Tooltip.SYS) then
		GameTooltip:AddLine(" ")
		GameTooltip:AddDoubleLine("|CFF00AAFF지연율 : |r "..get_latency().." |CFFFFFFFFms", "|CFF00AAFF메모리 : |r"..format("%.2f %s", gcinfo() / 1024,"|CFFFFFFFFMB"))
	end
	if (ToolsBarDB.Tooltip.DURA) then
		local value, total, cost = CheckDura(getn(InvItemID))
		cost = CostSplit(cost)
		GameTooltip:AddLine(" ")
		GameTooltip:AddDoubleLine("|CFF00AAFF내구도감소 : |r"..format("%0.1f%s",100-(value/total*100),"%"), "|CFF00AAFF수리비 : |r"..cost)
	end
	if (ToolsBarDB.Tooltip.BAG) then
		local empty, use = FindEmptySlot()
		GameTooltip:AddLine(" ")
		GameTooltip:AddLine("|CFF00AAFF가방공간|r  |CFFFFFFFF(총 "..empty+use.." 칸)")
		GameTooltip:AddDoubleLine("|CFFFFFFFF여유 : |r"..empty.." |CFFFFFFFF칸", "|CFFFFFFFF사용 : |r"..use.." |CFFFFFFFF칸")
	end
	GameTooltip:Show()
end
ToolsBarMinimap:SetScript("OnEnter", SetTooltip)