ToolsBar.GroupChange = true
ToolsBar.Select = 1
ToolsBar.GroupText = {[1] = "그룹", [2] = "태세전환", [3] = "소환수"}
ToolsBar.Slider = {
	[1] = {text = "가로버튼수", opt = "Col", MinMax = {0, 24}, tooltip = "한줄에 표시될 버튼의 갯수를 설정합니다"},
	[2] = {text = "세로줄의수", opt = "Row", MinMax = {1, 24}, tooltip = "확장될 그룹의 줄수를 설정합니다\n버튼갯수 / 줄수 가 아닌\n버튼갯수 * 줄수 가 그룹의 버튼 갯수입니다"},
	[3] = {text = "크기", opt = "Scale", step = 0.01, MinMax = {0.6, 2}, tooltip = "스케일을 조정하여 크기를 변경합니다"},
	[4] = {text = "버튼간격", opt = "GapButton", MinMax = {0, 50}, tooltip = "버튼과 버튼의 간격을 설정합니다"},
	[5] = {text = "배경과의간격", opt = "GapBorder", MinMax = {0, 25}, tooltip = "버튼과 배경과의 간격을 설정합니다"},
	[6] = {text = "테두리두께", opt = "Thickness", MinMax = {10, 24}, tooltip = "테두리의 두께를 설정합니다\n스케일 변화에 따라 두껍고 얇아지기에\n사용자가 직접 설정할 수 있도록 합니다"}}
ToolsBar.Color = {
	["resetText"] = "색상을 초기화 합니다",
	[1] = {text = "테두리", opt = "ColorBorder", tooltip="배경 테두리의 색상을 변경합니다\n테두리만 지우고 싶으시면\n투명도를 0으로 설정하세요", reset = {1, 1, 1, 1}, func = "ChangeBorderColor"},
	[2] = {text = "배경", opt = "ColorBackdrop", tooltip="배경의 색상을 변경합니다\n배경만 지우고 싶으시면\n투명도를 0으로 설정하세요", reset = {0, 0, 0, 0.4}, func = "ChangeBorderColor"},
	[3] = {text = "단축키", opt = "Hotkey", tooltip="단축키의 색상을 변경합니다\n(전체적용)", reset = {1, 1, 1}, func = "ChangeTextColor"},
	[4] = {text = "아이템 갯수", opt = "Count", tooltip="아이템 갯수의 색상을 변경합니다\n(전체적용)", reset = {1, 1, 0}, func = "ChangeTextColor"},
	[5] = {text = "매크로 이름", opt = "Name", tooltip="매크로 이름의 색상을 변경합니다\n(전체적용)", reset = {0, 1, 1}}, func = "ChangeTextColor"}
ToolsBar.CheckButton = {
	[1] = {text = "거리판별색\n(전체적용)", opt = "RangeColor", tooltip = "스킬사용불가 거리에 있을시\n붉은색으로 색상을 변경합니다"},
	[2] = {text = "버튼확장방향", opt = "Flip", tooltip = "체크시 버튼을 아래에서 위방향으로\n정렬합니다"},
	[3] = {text = "배경보이기", opt = "Show", tooltip = "그룹의 배경(보더)을 보이게 설정합니다\n체크 해제시 보이지 않습니다\n소환수바는 옵션창을 닫으면 적용 됩니다\n\n|CFFFFFF00정신지배나 다크문 통통전차등도 소환수바를 이용합니다"},
	[4] = {text = "공격/따르기/대기버튼\n숨기기", opt = "PetCompactMode", tooltip = "펫 액션바의 형태를 변경합니다\n체크시 간단하게 표시합니다"},
	[5] = {text = "태세전환 숨기기", opt = "HideShapeshiftBar", tooltip = "태세전환바의 사용유무를 설정합니다\n체크시 화면에서 숨깁니다"}}
ToolsBar.RadioButtonOverlay = {"없음", "타입"}
ToolsBar.RadioButtonBorder = {"기본", "사각", "클래식"}
ToolsBar.InputBoxText = {"R", "G", "B"}

-- [[ 체크 버튼 관련 ]]
function ToolsBar:CheckButtonOnLoad()
	this.opt = self.CheckButton[this:GetID()].opt
	this.tooltip = self.CheckButton[this:GetID()].tooltip or nil
	getglobal(this:GetName().."Text"):SetText(self.CheckButton[this:GetID()].text)
end
function ToolsBar:CheckButtonOnShow()
	if this:GetID() == 2 or this:GetID() == 3 then
		if ( ToolsBarDB[self.Select][this.opt] ) then
			this:SetChecked(true)
		else
			this:SetChecked(false)
		end
	else
		if ( ToolsBarDB[this.opt] ) then
			this:SetChecked(true)
		else
			this:SetChecked(false)
		end
	end
end
function ToolsBar:CheckButtonOnClick()
	if this:GetID() == 1 then
		if (this:GetChecked()) then
			ToolsBarDB[this.opt] = true
		else
			ToolsBarDB[this.opt] = nil
		end
	elseif this:GetID() == 5 then
		if (this:GetChecked()) then
			ToolsBarDB[this.opt] = true
		else
			ToolsBarDB[this.opt] = nil
		end
		self:SetShapeshiftBar()
	elseif this:GetID() == 4 then
		if (this:GetChecked()) then
			ToolsBarDB[this.opt] = true
		else
			ToolsBarDB[this.opt] = nil
		end
		ToolsBarDB[14].Col = ToolsBarDB[this.opt] and 7 or 10
		self:SetGroupButton(self.Select)
		self:SetBorderSize(self.Select)
	else
		if (this:GetChecked()) then
			ToolsBarDB[self.Select][this.opt] =  true
		else
			ToolsBarDB[self.Select][this.opt] = nil
		end
		if this:GetID() == 2 then
			self:SetGroupButton(self.Select)
		else
			self:SetBorderShow(self.Select)
		end
	end
end
-- [[ 체크버튼 해제용 ]]
function ToolsBar:RadioButtonCheckChange(text, loop, check)
	for i = 1, loop do
		if i == check then
			getglobal(text..i):SetChecked(true)
		else
			getglobal(text..i):SetChecked(false)
		end
	end
end
-- [[ 텍스쳐 선택 관련 ]]
function ToolsBar:OverlayTextureSelectOnLoad()
	if this:GetID() ~= 1 then
		getglobal(this:GetName().."Text"):SetText(self.RadioButtonOverlay[2]..this:GetID()-1)
	else
		getglobal(this:GetName().."Text"):SetText(self.RadioButtonOverlay[1])
	end
end
function ToolsBar:OverlayTextureSelectOnClick()
	ToolsBarDB[self.Select].Overlay = this:GetID()
	self:RadioButtonCheckChange("ToolsBarOPTOverlaySelect", 4, this:GetID())
	self:SetButtonOverlayTexture(self.Select)
end
-- [[ 보더 선택 관련 ]]
function ToolsBar:BorderTextureSelectOnLoad()
	getglobal(this:GetName().."Text"):SetText(self.RadioButtonBorder[this:GetID()])
end
function ToolsBar:BorderTextureSelectOnClick()
	ToolsBarDB[self.Select].Border = this:GetID()
	self:RadioButtonCheckChange("ToolsBarOPTBorderSelect", 3, this:GetID())
	self:SetBorder(self.Select)
	self:SetBorderColor(self.Select)	
end
-- [[ 그룹 선택 관련 ]]
function ToolsBar:GroupSelectOnLoad()
	local id = this:GetID()
	local text = getglobal(this:GetName().."Text")
	if id <= 12 then
		text:SetText(self.GroupText[1]..id)
	elseif id == 13 then
		text:SetText(self.GroupText[2])
	else
		text:SetText(self.GroupText[3])
	end
end
function ToolsBar:GroupSelectOnClick(id)
	id = id or this:GetID()
	self.Select = id
	self.GroupChange = true
	self:EnbaleOrDisableCheck()
	ToolsBarOPTGroupColorPicker1:SetBackdropColor(unpack(ToolsBarDB[self.Select].ColorBorder))
	ToolsBarOPTGroupColorPicker2:SetBackdropColor(unpack(ToolsBarDB[self.Select].ColorBackdrop))
	if ( ToolsBarDB[self.Select].Flip ) then
		ToolsBarOPTCheckButton2:SetChecked(true)
	else
		ToolsBarOPTCheckButton2:SetChecked(false)
	end
	if ( ToolsBarDB[self.Select].Show ) then
		ToolsBarOPTCheckButton3:SetChecked(true)
	else
		ToolsBarOPTCheckButton3:SetChecked(false)
	end
	self:RadioButtonCheckChange("ToolsBarOPTGroupButton", 14, self.Select)
	self:RadioButtonCheckChange("ToolsBarOPTBorderSelect", 3, ToolsBarDB[self.Select].Border)
	self:RadioButtonCheckChange("ToolsBarOPTOverlaySelect", 4, ToolsBarDB[self.Select].Overlay)
	for k,v in pairs(self.Slider) do
		getglobal("ToolsBarOPTSlider"..k):SetValue(ToolsBarDB[self.Select][v.opt])
	end
	self.GroupChange = nil
end
function ToolsBar:EnbaleOrDisableCheck()
	if self.Select <= 12 then
		ToolsBarOPTPetMode:Hide()
		ToolsBarOPTShapeshiftBar:Hide()
		ToolsBarOPTSlider1:Show()
		ToolsBarOPTSlider2:Show()
	else
		if self.Select == 13 then
			ToolsBarOPTShapeshiftBar:Show()
			ToolsBarOPTPetMode:Hide()
		elseif self.Select == 14 then
			ToolsBarOPTPetMode:Show()
			ToolsBarOPTShapeshiftBar:Hide()
		else
			ToolsBarOPTShapeshiftBar:Hide()
			ToolsBarOPTPetMode:Hide()
		end
		ToolsBarOPTSlider1:Hide()
		ToolsBarOPTSlider2:Hide()
	end
	if (ToolsBarDB.Total == 60 and ToolsBarDB[self.Select].Col == 0) or
	(self.Select > 1 and ToolsBarDB[self.Select-1].Col == 0 and ToolsBarDB[self.Select].Col == 0) then
		for i = 1, 6 do
			self:SetSliderDisable(i)
		end
		ToolsBarOPTCheckButton2:Disable()
		ToolsBarOPTCheckButton2Text:SetVertexColor(0.5,0.5,0.5)
		ToolsBarOPTCheckButton3:Disable()
		ToolsBarOPTCheckButton3Text:SetVertexColor(0.5,0.5,0.5)
	else
		for i = 1, 6 do
			if i == 2 then
				if ToolsBarDB[self.Select].Col == 0 then
					self:SetSliderDisable(i)
				else
					self:SetSliderEnbale(i)
				end
			else
				self:SetSliderEnbale(i)
			end
		end
		if self.Select <= 12 then
			ToolsBarOPTCheckButton2:Enable()
			ToolsBarOPTCheckButton2Text:SetVertexColor(1,0.82,0)
		else
			ToolsBarOPTCheckButton2:Disable()
			ToolsBarOPTCheckButton2Text:SetVertexColor(0.5,0.5,0.5)
		end
		ToolsBarOPTCheckButton3:Enable()
		ToolsBarOPTCheckButton3Text:SetVertexColor(1,0.82,0)
	end
	if ToolsBarDB[self.Select].Col == 0 then
		ToolsBarOPTGroupColorPicker1:Disable()
		ToolsBarOPTGroupColorPicker2:Disable()
	else
		ToolsBarOPTGroupColorPicker1:Enable()
		ToolsBarOPTGroupColorPicker2:Enable()
	end
end
--- [[ 색상관련 ]]
local function ClearColorPickerfunc()
	if ColorPickerFrame:IsVisible() then return end
	ColorPickerFrame.opacityFunc = nil
	ColorPickerFrame.swatchFunc = nil
	ColorPickerFrame.cancelFunc = nil
	ColorPickerFrame:SetScript("OnKeyDown", ToolsBar.ColorPickerOnkeyDown)
	Tools_SetPoint(ColorPickerFrame, 5, 0, 5, 0, 0)
end
function ToolsBar:ColorSwatchReset()	-- 초기화버튼
	self:ColorSwatchShownCheck()
	self.ColorPickerOPT = this:GetParent()
	self[self.Color[this:GetParent():GetID()].func](self, unpack(self.Color[this:GetParent():GetID()].reset))
	self:HideInputBox()
end

function ToolsBar:ColorPickerInputBoxOnEnterPressed()
	ColorPickerFrame:SetColorRGB(tonumber(ToolsBarOPTInputColor1Input:GetText())/255, tonumber(ToolsBarOPTInputColor2Input:GetText())/255, tonumber(ToolsBarOPTInputColor3Input:GetText())/255)
end
function ToolsBar:ColorPickerInputBoxOnLoad()
	getglobal(this:GetName().."Text"):SetText(self.InputBoxText[this:GetID()])
	this:Hide()
end

function ToolsBar:ColorSwatchOnLoad()
	self.ColorPickerOnkeyDown = ColorPickerFrame:GetScript("OnKeyDown")
	this.opt = self.Color[this:GetID()].opt
	this.tooltip = self.Color[this:GetID()].tooltip or nil
	getglobal(this:GetName().."Text"):SetText(self.Color[this:GetID()].text)
	getglobal(this:GetName().."Reset").tooltip = self.Color[this:GetID()].text..self.Color.resetText
	getglobal(this:GetName().."Reset"):SetBackdropColor(unpack(self.Color[this:GetID()].reset))
end
function ToolsBar:ColorPickerInputBoxTextChange(r,g,b)
	ToolsBarOPTInputColor1Input:SetText(r*255)
	ToolsBarOPTInputColor2Input:SetText(g*255)
	ToolsBarOPTInputColor3Input:SetText(b*255)
end
function ToolsBar:ColorSwatchShownCheck()
	self.ColorPickerOPT = this
	if ColorPickerFrame:IsVisible() then
		ColorPickerFrame:Hide()
	end
	ClearColorPickerfunc()
end
function ToolsBar:ChangeBorderColor(r, g, b, a)
	if not (r) then
		r,g,b = ColorPickerFrame:GetColorRGB()
		a = 1 - OpacitySliderFrame:GetValue()
	end
	self:ColorPickerInputBoxTextChange(r,g,b)
	ClearColorPickerfunc()
	ToolsBarDB[self.Select][self.ColorPickerOPT.opt] = {r,g,b,a}
	self:SetBorderColor(self.Select)
	self.ColorPickerOPT:SetBackdropColor(r,g,b,a)
	self:HideInputBox()
end
function ToolsBar:HideInputBox()
	if ColorPickerFrame:IsShown() then return end
	ToolsBarOPTInputColor1:Hide()
	ToolsBarOPTInputColor2:Hide()
	ToolsBarOPTInputColor3:Hide()
end
function ToolsBar:ColorSwatchForGroupOnClick()
	local r,g,b,a = unpack(ToolsBarDB[self.Select][this.opt])
	self:ColorSwatchShownCheck()
	ColorPickerFrame.opacity = 1 - a
	ColorPickerFrame:SetColorRGB(r, g, b)
	ColorPickerFrame.previousValues = {r, g, b, a}
	ColorPickerFrame.hasOpacity = true
	ColorPickerFrame.opacityFunc = function() self:ChangeBorderColor() end
	ColorPickerFrame.func = function() self:ChangeBorderColor() end
	ColorPickerFrame.cancelFunc = function() self:ChangeBorderColor(unpack(ColorPickerFrame.previousValues)) end
	ColorPickerFrame:Show()
	ToolsBarOPTInputColor1:Show()
	ToolsBarOPTInputColor2:Show()
	ToolsBarOPTInputColor3:Show()
	ColorPickerFrame:SetScript("OnKeyDown", nil)
	self:ColorPickerInputBoxTextChange(ColorPickerFrame:GetColorRGB())
	Tools_SetPoint(ColorPickerFrame, 8, ToolsBar_OptionFrame, 2, 0, 0)
end
function ToolsBar:ChangeTextColor(r,g,b)
	if not (r) then
		r,g,b = ColorPickerFrame:GetColorRGB()
	end
	self:ColorPickerInputBoxTextChange(r,g,b)
	ClearColorPickerfunc()
	ToolsBarDB.Color[self.ColorPickerOPT.opt] = {r,g,b}
	self:InitButton()
	self.ColorPickerOPT:SetBackdropColor(r,g,b)
	self:HideInputBox()
end
function ToolsBar:ColorSwatchForTextOnClick()
	local r,g,b,a = unpack(ToolsBarDB.Color[this.opt])
	self:ColorSwatchShownCheck()
	ColorPickerFrame:SetColorRGB(r, g, b)
	ColorPickerFrame.previousValues = {r, g, b}
	ColorPickerFrame.hasOpacity = false
	ColorPickerFrame.func = function() self:ChangeTextColor() end
	ColorPickerFrame.cancelFunc = function() self:ChangeTextColor(unpack(ColorPickerFrame.previousValues)) end
	ColorPickerFrame:Show()
	ToolsBarOPTInputColor1:Show()
	ToolsBarOPTInputColor2:Show()
	ToolsBarOPTInputColor3:Show()
	ColorPickerFrame:SetScript("OnKeyDown", nil)
	self:ColorPickerInputBoxTextChange(ColorPickerFrame:GetColorRGB())
	Tools_SetPoint(ColorPickerFrame, 8, ToolsBar_OptionFrame, 2, 0, 0)
end
-- [[ 슬라이더바 사용 / 미사용 설정 ]]
function ToolsBar:SetSliderEnbale(i)
	getglobal("ToolsBarOPTSlider"..i):EnableMouse(true)
	getglobal("ToolsBarOPTSlider"..i):SetAlpha(1)
	getglobal("ToolsBarOPTSlider"..i.."UpButton"):Enable()
	getglobal("ToolsBarOPTSlider"..i.."DownButton"):Enable()
end
function ToolsBar:SetSliderDisable(i)
	getglobal("ToolsBarOPTSlider"..i):EnableMouse(false)
	getglobal("ToolsBarOPTSlider"..i):SetAlpha(0.5)
	getglobal("ToolsBarOPTSlider"..i.."UpButton"):Disable()
	getglobal("ToolsBarOPTSlider"..i.."DownButton"):Disable()
end
-- [[ 슬라이더바 관련 ]]
local function SetButtonNumberText()
	ToolsBarOPTTotalText:SetText("60개의 버튼중 |CFFFFFF00"..ToolsBarDB.Total.."|r개 사용중 |CFFFFFF00"..60-ToolsBarDB.Total.."|r남음")
end
function ToolsBar:SliderOnLoad()
	local opt = self.Slider[this:GetID()]
	opt.step = opt.step or 1
	this.opt = opt.opt
	this.tooltip = opt.tooltip
	this:SetMinMaxValues(unpack(opt.MinMax))
	this:SetValueStep(opt.step)
	getglobal(this:GetName().."Text"):SetText(opt.text)
	getglobal(this:GetName().."UpButton"):SetScript("OnClick", function() this:GetParent():SetValue(this:GetParent():GetValue()+opt.step) end)
	getglobal(this:GetName().."DownButton"):SetScript("OnClick", function() this:GetParent():SetValue(this:GetParent():GetValue()-opt.step) end)
end
function ToolsBar:SetSliderOnValueChange()
	local id = this:GetID()

	if id == 3 then
		getglobal(this:GetName().."Value"):SetText(format("%0.0f%s",this:GetValue()*100,"%"))
	else
		getglobal(this:GetName().."Value"):SetText(this:GetValue())
	end

	if id == 1 then
		if this:GetValue() == 0 then
			self:SetSliderDisable(2)
			ToolsBarOPTGroupColorPicker1:Disable()
			ToolsBarOPTGroupColorPicker2:Disable()
		else
			self:SetSliderEnbale(2)
			ToolsBarOPTGroupColorPicker1:Enable()
			ToolsBarOPTGroupColorPicker2:Enable()
		end
	end

	if (self.GroupChange) then return end			-- 그룹 선택시 슬라이더 값 변동으로 실행되는거 방지용

	if id > 2 then
		ToolsBarDB[self.Select][this.opt] = this:GetValue()
	end

	if id <= 2 then					--[[버튼갯수 조정]]
		self.Prev = ToolsBarDB[self.Select][this.opt]	-- 버튼 합이 60개를 넘을때 대비하여 기존 값 저장
		ToolsBarDB[self.Select][this.opt] = this:GetValue()	-- 값 변경
		self:SetButtonID()					-- ID(툴스바 일괄 적용용) 가져오기
		if ToolsBarDB.Total > 60 then				-- 버튼총합이 60개 초과시 실행 안함
			ToolsBarDB[self.Select][this.opt] = self.Prev	-- 기존값 복원
			self:SetButtonID()				-- ID 재배열
			self:GroupSelectOnClick(self.Select)		-- 값변동으로 인한 재 실행없게 그룹선택으로 값변경
			self.Prev = nil					-- 기존값 제거
			return						-- 빠져나가기
		end
		for i = 1, 12 do						-- [12번 반복]
			self:SetGroupButton(i)				-- 버튼위치 재설정하기
			self:SetBorderSize(i)				-- 프레임 다시 그리기
			self:SetScale(i)					-- 스케일 변경하기
			self:HideButton()					-- 남는 버튼 숨기기
			self:SetButtonOverlayTexture(i)
		end
		SetButtonNumberText()
		self:SetBorderShow(self.Select)			-- 보이기 숨기기(버튼 없을시 숨기기적용)
	elseif id == 3 then				-- [[스케일 조정]]
		self:SetScale(self.Select)				-- 스케일 변경하기
		self:UpdateFramePoint(self.Select)			-- 위치 재 배열하기(크기 변화에 따른 재 조정)
	elseif id <= 5 then				-- [[간격 조정]]
		self:SetGroupButton(self.Select)			-- 버튼위치 재설정하기
		self:SetBorderSize(self.Select)			-- 프레임 다시 그리기
	elseif id == 6 then				-- [[테두리두께 조정]]
		self:SetBorder(self.Select)				-- 보더 설정하기
		self:SetBorderColor(self.Select)			-- 보더 색상 설정하기
	end
end
-- [[ 버튼 재배열 ID 설정 ]]
function ToolsBar:SetButtonID()
	if self.Select > 12 then return end		-- 선택한 그룹이 12번 보다 크면 ID재배열 안함
	local group, total, first, last = 0, 0, 0, 0
	for i = 1, 12 do
		group = ToolsBarDB[i].Col * ToolsBarDB[i].Row		-- 그룹의 버튼 갯수 검사
		total = total + group						-- i번 그룹까지의 총합
		first = total - group + 1						-- i번 그룹의 시작 버튼
		last = first + group - 1						-- i번 그룹의 마지막 버튼
		if group == 0 then
			ToolsBarDB[i].ID = nil					-- 그룹의 버튼이 없으면 ID 제거
		else
			ToolsBarDB[i].ID = {Start = first, Last = last}	-- i번 그룹 데이터에 ID에 시작과 끝 저장
		end
	end
	ToolsBarDB.Total = total						-- 버튼의 총합 저장
end
-- [[ 드래그 프레임 관련 ]]
function ToolsBar:DragOnDragStart()
	local x, y = GetCursorPosition()
	local f = getglobal("ToolsBarGroup"..this:GetID())
	f:StartMoving()
	Tools_SetPoint(f, 7, 0, 1, x / f:GetEffectiveScale(), y / f:GetEffectiveScale())
end
function ToolsBar:DragOnDragStop()
	local f = getglobal("ToolsBarGroup"..this:GetID())
	f:StopMovingOrSizing()

	ToolsBarDB[this:GetID()].Xpoint = f:GetLeft() * f:GetEffectiveScale()
	ToolsBarDB[this:GetID()].Ypoint = f:GetTop() * f:GetEffectiveScale()
end
function ToolsBar:DragOnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT")
	local id = this:GetID()
	if id <= 12 then
		GameTooltip:SetText("버튼그룹 "..id, 0.65, 0.86, 0.96, 1)
	elseif id == 13 then
		GameTooltip:SetText("태세전환바", 0.65, 0.86, 0.96, 1)
	elseif id == 14 then
		GameTooltip:SetText("소환수바", 0.65, 0.86, 0.96, 1)
	elseif id == 15 then
		GameTooltip:SetText("메뉴바", 0.65, 0.86, 0.96, 1)
	elseif id == 16 then
		GameTooltip:SetText("가방바", 0.65, 0.86, 0.96, 1)
	end
	GameTooltip:AddLine("클릭 : |CFFFFFFFF설정프레임 변경|r")
	GameTooltip:AddLine("드래그 : |CFFFFFFFF이동|r")
	GameTooltip:Show()
end
-- [[ 옵션 프레임 관련 설정 ]]
function ToolsBar:OptionOnShow()
	SetButtonNumberText()
	self:GroupSelectOnClick(self.Select)
	ToolsBarOPTTextColorPicker1:SetBackdropColor(unpack(ToolsBarDB.Color.Hotkey))
	ToolsBarOPTTextColorPicker2:SetBackdropColor(unpack(ToolsBarDB.Color.Count))
	ToolsBarOPTTextColorPicker3:SetBackdropColor(unpack(ToolsBarDB.Color.Name))
	for i = 1, 14 do
		getglobal("ToolsBarDragButton"..i):Show()
	end
end
function ToolsBar:OptionOnHide()
	if not (UnitIsVisible("pet")) then
		PetActionBarFrame:Hide()
	end
	self:SetBorderShow(14)
	for i = 1, 14 do
		getglobal("ToolsBarDragButton"..i):Hide()
	end
	ClearColorPickerfunc()
	self:HideInputBox()
end
function ToolsBar:OptionOnUpdate()
	if not (UnitIsVisible("pet")) then
		PetActionBarFrame:Show()
	end
	for i = 1, 14 do
		if i == 14 then
			ToolsBarGroup14:Show()
		end
		if ToolsBarDB[i].Col ~= 0 then
			getglobal("ToolsBarDragButton"..i):Show()
		else
			getglobal("ToolsBarDragButton"..i):Hide()
		end
	end
end
---------------------------------------------------------------------------------[이벤트설정]
ToolsEventReg("ToolsBarOpt", "ADDON_LOADED",
	function()
		if arg1 == "ToolsBar_Option" then
			tremove(ToolsDropdown.ToolsBarMinimap[1], getn(ToolsDropdown.ToolsBarMinimap[1]))
			tinsert(ToolsDropdown.ToolsBarMinimap[1], {text = "옵션", func =
				function () 
					if (ToolsBar_OptionFrame:IsShown()) then
						ToolsBar_OptionFrame:Hide()
					else
						ToolsBar_OptionFrame:Show()
					end
				end, justifyH="LEFT"})
			ToolsBar:SetFrameLayout()

			tinsert(UISpecialFrames, "ToolsBar_OptionFrame")
			ToolsBarOpt:UnregisterEvent("ADDON_LOADED")
		end
	end)
---------------------------------------------------------------------------------[레이아웃설정]
function ToolsBar:SetFrameLayout()
	local frameData = {
		{	Frame = "ToolsBar_OptionFrame",
			Point = {5,0,5,0,0},
			Size = {360, 320}, Border = {20,6,"LOW"},
			Color = {border = {1,1,0,1}, backdrop = {0,0,0,0.6}}	},

		{	Frame = "ToolsBarOPTGroupBG",
			Point = {7, ToolsBar_OptionFrame, 7, 10, -10},
			Size = {80, 300}, Border = {12, 2,"LOW"},
			Color = {border = {1,1,0,1}, backdrop = {0,0,0,0.7}}	},
		{	Frame = "ToolsBarOPTGroupButton1",
			Point = {9, ToolsBarOPTGroupBG, 7, 23, -5}		},
		{	Frame = "ToolsBarOPTGroupButton2",
			Point = {8, ToolsBarOPTGroupButton1, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton3",
			Point = {8, ToolsBarOPTGroupButton2, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton4",
			Point = {8, ToolsBarOPTGroupButton3, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton5",
			Point = {8, ToolsBarOPTGroupButton4, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton6",
			Point = {8, ToolsBarOPTGroupButton5, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton7",
			Point = {8, ToolsBarOPTGroupButton6, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton8",
			Point = {8, ToolsBarOPTGroupButton7, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton9",
			Point = {8, ToolsBarOPTGroupButton8, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton10",
			Point = {8, ToolsBarOPTGroupButton9, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton11",
			Point = {8, ToolsBarOPTGroupButton10, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton12",
			Point = {8, ToolsBarOPTGroupButton11, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton13",
			Point = {8, ToolsBarOPTGroupButton12, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupButton14",
			Point = {8, ToolsBarOPTGroupButton13, 2, 0, -5}	},

		{	Frame = "ToolsBarOPTSlider1",
			Point = {7, ToolsBarOPTGroupBG, 9, 15, -100}		},
		{	Frame = "ToolsBarOPTSlider2",
			Point = {8, ToolsBarOPTSlider1, 2, 0, -18}		},
		{	Frame = "ToolsBarOPTSlider3",
			Point = {8, ToolsBarOPTSlider2, 2, 0, -18}		},
		{	Frame = "ToolsBarOPTSlider4",
			Point = {8, ToolsBarOPTSlider3, 2, 0, -18}		},
		{	Frame = "ToolsBarOPTSlider5",
			Point = {8, ToolsBarOPTSlider4, 2, 0, -18}		},
		{	Frame = "ToolsBarOPTSlider6",
			Point = {8, ToolsBarOPTSlider5, 2, 0, -18}		},

		{	Frame = "ToolsBarOPTPetMode",
			Point = {7, ToolsBarOPTGroupBG, 9, 10, -100}		},
		{	Frame = "ToolsBarOPTShapeshiftBar",
			Point = {7, ToolsBarOPTGroupBG, 9, 10, -100}		},

		{	Frame = "ToolsBarOPTGroupColorPickerText",
			Point = {7, ToolsBarOPTGroupBG, 9, 180, -80}		},
		{	Frame = "ToolsBarOPTGroupColorPicker1",
			Point = {8, ToolsBarOPTGroupColorPickerText, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTGroupColorPicker2",
			Point = {8, ToolsBarOPTGroupColorPicker1, 2, 0, -2}	},
		{	Frame = "ToolsBarOPTCheckButton2",
			Point = {7, ToolsBarOPTGroupColorPicker2, 1, -5, -5}	},
		{	Frame = "ToolsBarOPTCheckButton3",
			Point = {7, ToolsBarOPTCheckButton2, 1, 0, 10}	},

		{	Frame = "ToolsBarOPTTextColorPickerText",
			Point = {8, ToolsBarOPTGroupColorPicker2, 2, 0, -65}	},
		{	Frame = "ToolsBarOPTTextColorPicker1",
			Point = {8, ToolsBarOPTTextColorPickerText, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTTextColorPicker2",
			Point = {8, ToolsBarOPTTextColorPicker1, 2, 0, -2}	},
		{	Frame = "ToolsBarOPTTextColorPicker3",
			Point = {8, ToolsBarOPTTextColorPicker2, 2, 0, -2}	},

		{	Frame = "ToolsBarOPTCheckButton1",
			Point = {7, ToolsBarOPTTextColorPicker3, 1, -5, -5}	},

		{	Frame = "ToolsBarOPTBorderSelectText",
			Point = {7, ToolsBarOPTGroupBG, 9, 15, -5}		},
		{	Frame = "ToolsBarOPTBorderSelect1",
			Point = {7, ToolsBarOPTGroupBG, 9, 15, -20}		},
		{	Frame = "ToolsBarOPTBorderSelect2",
			Point = {7, ToolsBarOPTBorderSelect1, 9, 40, 0}	},
		{	Frame = "ToolsBarOPTBorderSelect3",
			Point = {7, ToolsBarOPTBorderSelect2, 9, 40, 0}	},

		{	Frame = "ToolsBarOPTOverlaySelectText",
			Point = {7, ToolsBarOPTGroupBG, 9, 15, -45}		},
		{	Frame = "ToolsBarOPTOverlaySelect1",
			Point = {7, ToolsBarOPTGroupBG, 9, 15, -60}		},
		{	Frame = "ToolsBarOPTOverlaySelect2",
			Point = {7, ToolsBarOPTOverlaySelect1, 9, 40, 0}	},
		{	Frame = "ToolsBarOPTOverlaySelect3",
			Point = {7, ToolsBarOPTOverlaySelect2, 9, 40, 0}	},
		{	Frame = "ToolsBarOPTOverlaySelect4",
			Point = {7, ToolsBarOPTOverlaySelect3, 9, 40, 0}	},

		{	Frame = "ToolsBarOPTInputColor1",
			Border = {12,6, "DIALOG"}, Color = {border = {1,1,1,1}, backdrop = {0,0,0,0.6}},
			Point = {7, ColorPickerFrame, 7, 220, -75}		},
		{	Frame = "ToolsBarOPTInputColor2",
			Border = {12,6, "DIALOG"}, Color = {border = {1,1,1,1}, backdrop = {0,0,0,0.6}},
			Point = {8, ToolsBarOPTInputColor1, 2, 0, -5}	},
		{	Frame = "ToolsBarOPTInputColor3",
			Border = {12,6, "DIALOG"}, Color = {border = {1,1,1,1}, backdrop = {0,0,0,0.6}},
			Point = {8, ToolsBarOPTInputColor2, 2, 0, -5}	},
	}
	for i = 1, getn(frameData) do
		FrameManager(frameData[i])
	end
end